//+------------------------------------------------------------------+
//|                                                  TEMA ribbon.mq4 |
//|                                               mladenfx@gmail.com |
//|                                                                  |
//+------------------------------------------------------------------+
#property copyright "mladen"
#property link      "mladenfx@gmail.com"

#property indicator_chart_window
#property indicator_buffers 8
#property indicator_color1 LimeGreen
#property indicator_color2 DarkOrange
#property indicator_color3 Red
#property indicator_color4 Green
#property indicator_color5 DeepSkyBlue
#property indicator_color6 PaleVioletRed
#property indicator_color7 White
#property indicator_color8 Silver
#property indicator_width1 3
#property indicator_width2 3
#property indicator_width3 2
#property indicator_width4 2
#property indicator_style5 STYLE_DOT
#property indicator_style6 STYLE_DOT
#property indicator_style7 STYLE_DOT
#property indicator_style8 STYLE_DOT

//
//
//
//
//

extern bool ShowTEMARibbon = true;
extern int  TEMA1Period    = 12;
extern int  TEMA1Price     = PRICE_CLOSE;
extern int  TEMA2Period    = 26;
extern int  TEMA2Price     = PRICE_CLOSE;
extern bool ShowDayHighLow = true;

extern bool alertsOn        = true;
extern bool alertsOnCurrent = true;
extern bool alertsMessage   = true;
extern bool alertsSound     = false;
extern bool alertsEmail     = false;

//
//
//
//
//

double buffer1[];
double buffer2[];
double buffer3[];
double buffer4[];
double high[];
double low[];
double open[];
double median[];

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

int init()
{
   int type1 = DRAW_NONE; if (ShowTEMARibbon) type1 = DRAW_HISTOGRAM;
   int type2 = DRAW_NONE; if (ShowTEMARibbon) type2 = DRAW_LINE;
   int type3 = DRAW_NONE; if (ShowDayHighLow) type3 = DRAW_LINE;
   SetIndexBuffer(0,buffer3); SetIndexStyle(0,type1);
   SetIndexBuffer(1,buffer4); SetIndexStyle(1,type1);
   SetIndexBuffer(2,buffer1); SetIndexStyle(2,type2);
   SetIndexBuffer(3,buffer2); SetIndexStyle(3,type2);
   SetIndexBuffer(4,high);    SetIndexStyle(4,type3);
   SetIndexBuffer(5,low);     SetIndexStyle(5,type3); 
   SetIndexBuffer(6,open);    SetIndexStyle(6,type3);
   SetIndexBuffer(7,median);  SetIndexStyle(7,type3);
      if (TEMA1Period>TEMA2Period)
      {
         int temp = TEMA1Period;
                    TEMA1Period = TEMA2Period;
                    TEMA2Period = temp;
      }                    
   return(0);
}
int deinit()
{
   return(0);
}

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

double tBuffer[][7];
int start()
{
   int counted_bars=IndicatorCounted();
   int limit,i,r;
   
   if(counted_bars<0) return(-1);
   if(counted_bars>0) counted_bars--;
           limit=MathMin(Bars-counted_bars,Bars-1);
           limit=MathMax(limit,iBarShift(NULL,0,iTime(NULL,PERIOD_D1,0)));
           if (ArrayRange(tBuffer,0) != Bars) ArrayResize(tBuffer,Bars);

   //
   //
   //
   //
   //

   for(i=limit, r=Bars-i-1; i>=0; i--,r++)
   {
      buffer1[i] = iTema(iMA(NULL,0,1,0,MODE_SMA,TEMA1Price,i),TEMA1Period,i,0);
      buffer2[i] = iTema(iMA(NULL,0,1,0,MODE_SMA,TEMA2Price,i),TEMA2Period,i,3);
      buffer3[i] = buffer1[i];
      buffer4[i] = buffer2[i];
      tBuffer[r][6] = tBuffer[r-1][6];
      
         if (buffer1[i]>buffer2[i]) tBuffer[r][6] =  1;
         if (buffer1[i]<buffer2[i]) tBuffer[r][6] = -1;
         
         //
         //
         //
         //
         //
         
         high[i]   = high[i+1];
         low[i]    = low[i+1];
         open[i]   = open[i+1];
         median[i] = median[i+1];
            int y = iBarShift(NULL,PERIOD_D1,Time[i]);
            int x = iBarShift(NULL,PERIOD_D1,Time[i+1]);
            if (x!=y)
            {
               high[i]   = iHigh(NULL,PERIOD_D1,x);
               low[i]    = iLow(NULL,PERIOD_D1,x);
               open[i]   = iOpen(NULL,PERIOD_D1,y);
               median[i] = (high[i]+low[i])/2.0;
            }
   }

   //
   //
   //
   //
   //
   
   if (alertsOn)
   {
      if (alertsOnCurrent)
           int whichBar = 0;
      else     whichBar = 1; whichBar = Bars-whichBar-1;
      if (tBuffer[whichBar][6] != tBuffer[whichBar-1][6])
      {
         if (tBuffer[whichBar][6] ==  1) doAlert("up");
         if (tBuffer[whichBar][6] == -1) doAlert("down");
      }
   }

   //
   //
   //
   //
   //
      
   return(0);
}

//+-------------------------------------------------------------------
//|                                                                  
//+-------------------------------------------------------------------
//
//
//
//
//

void doAlert(string doWhat)
{
   static string   previousAlert="nothing";
   static datetime previousTime;
   string message;
   
   if (previousAlert != doWhat || previousTime != Time[0]) {
       previousAlert  = doWhat;
       previousTime   = Time[0];

       //
       //
       //
       //
       //

       message =  StringConcatenate(Symbol()," at ",TimeToStr(TimeLocal(),TIME_SECONDS)," TEMA "+TEMA1Period+" crossed TEMA "+TEMA2Period+" ",doWhat);
          if (alertsMessage) Alert(message);
          if (alertsEmail)   SendMail(StringConcatenate(Symbol(),"TEMA ribbon "),message);
          if (alertsSound)   PlaySound("alert2.wav");
   }
}

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

double iTema(double price,int period,int shift,int forBuffer)
{
   double alpha = 2.0 /(1.0 + period);
   int i = Bars-shift-1;
   if (i < 1)
      {
         tBuffer[i][0+forBuffer] = price;
         tBuffer[i][1+forBuffer] = price;
         tBuffer[i][2+forBuffer] = price;
      }
   else
      {
         tBuffer[i][0+forBuffer] = tBuffer[i-1][0+forBuffer]+alpha*(price                  -tBuffer[i-1][0+forBuffer]);
         tBuffer[i][1+forBuffer] = tBuffer[i-1][1+forBuffer]+alpha*(tBuffer[i][0+forBuffer]-tBuffer[i-1][1+forBuffer]);
         tBuffer[i][2+forBuffer] = tBuffer[i-1][2+forBuffer]+alpha*(tBuffer[i][1+forBuffer]-tBuffer[i-1][2+forBuffer]);
      }
   return(3*tBuffer[i][0+forBuffer] - 3*tBuffer[i][1+forBuffer] + tBuffer[i][2+forBuffer]);
}